
angular.module('beamng.apps')
.directive('speedTimer', ['$log', 'bngApi', 'StreamsManager', function ($log, bngApi, StreamsManager) {
  return {
    template:
        '<div style="margin: 10px; background-color: rgba(255, 255, 255, 0.4); padding:10px; box-shadow: 0px 0px 5px 0px rgba(0,0,0,0.75);"><div style="width:100%; height:100%; background-color: rgba(255, 255, 255, 0.9); padding:10px;" layout="column">'   
      
      + '<div layout="row" layout-align="space-between">'
         
          + '<div layout="column" >'
                +'<div style="font-size: 1.5em; text-align:center;">' + "{{ timer | date:'mm:ss'  }}" + '</div>' 
                +'<div style="font-size: 0.7em; text-align:center;">' + "{{speed_color == 'green' ? 'TIME' : 'LAST TIME'}}"  + '</div>'
          + '</div>'
      
          + '<div layout="row" layout-align="space-between">'
                +'<div flex="60" style="font-size: 1.5em; text-align:left; color: {{speed_color}};">' + "{{speed > 0 ? '+' : ''}}{{ speed }}"  + '</div>' 
                +'<div flex="40" style="font-size: 1em; padding-top:5px; text-align:right;">' + '{{ units.label }}' + '</div>'
          + '</div>'
      
          + '<div layout="column" >'
                +'<div style="font-size: 1.5em; text-align:center;">' + "{{ best_time | date:'mm:ss'  }}" + '</div>' 
                +'<div style="font-size: 0.7em; text-align:center;">' + "BEST TIME" + '</div>'
          + '</div>'
          
    + '</div>'
      
    + '<div layout="column">'
        +'<div style=" display:' + "{{settings ? 'visible' : 'none'}}" + ';" ><md-slider flex min=10 max=300 ng-model="goal" step="5"></md-slider></div>'
        +'<md-button class="md-flat" style=" text-transform: none; width: 50%; margin: -10px auto -10px;  font-size: 0.7em;" ng-click="buttonClick()">Goal Speed  @ {{ goal }} {{ units.label }}</md-button>'
    + '</div>'
 
    + '<div layout="row" layout-align="space-between" style="margin-top:15px;">'
        + '<div flex="50" style="margin:0 2px 0 -2px; background-color: red; hegiht: 5px; overflow: hidden;"><div style="font-size: 6px; background-color: #b2b3b5; width:{{(speed/goal)*100+100}}%;">&nbsp;</div></div>'
        +'<div flex="50" style="margin:0 0 0 2px;background-color: #b2b3b5; hegiht: 5px; overflow: hidden;"><div style="font-size: 6px; background-color: green; width:'+ "{{((speed/goal)*100)<0 ? '0' : (speed/goal)*100}}" +'%; ">&nbsp;</div></div>'
    + '</div>'  
+      

"</div></div>",
      
      
    replace: true,
    restrict: 'EA',
      
    controller: ['$scope', function ($scope) {
      $scope.goal = 100;

      //clear values if goal is changed
      $scope.$watch('goal', function (newVal, oldVal) {
        $scope.best_time = 0;
        $scope.start_time = 0;
        $scope.timer = 0;
          
      }, true);
        
      $scope.settings = false;
      $scope.buttonClick = function() { 
        if($scope.settings) {
            $scope.settings = false;
        }
          else{
              $scope.settings = true;
          }
      };
        
    }],
      

    link: function (scope, element, attrs) {
      'use strict';
      StreamsManager.add(['electrics']);

      scope.$on('$destroy', function () {
        $log.debug('<speed-timer> destroyed');
        StreamsManager.remove(['electrics']);
      });

      var unitSystems = {
        imperial: {speedFactor: 2.236, label: 'mph'},
        metric: {speedFactor: 3.6, label: 'km/h'}
      };
    


      scope.speed = NaN;
      scope.units = unitSystems.metric;
      scope.goal = 100;
      scope.speed_color = 'red';
      scope.timer = 0;
      scope.best_time = 0;


      scope.$on('SettingsChanged', function (event, data) {
        var uiUnits = data.values.uiUnits;

        if (unitSystems[uiUnits]) {
          scope.$evalAsync(function () {
            scope.units = unitSystems[uiUnits];
          });
        } else {
          $log.warn('<speed-timer> Attempted to change to unknown units %s', uiUnits);
        }
      });

      scope.$on('streamsUpdate', function (event, streams) {  
        scope.$evalAsync(function () {
          var speedMs = streams.electrics.wheelspeed;
          if (isNaN(speedMs)) speedMs = streams.electrics.airspeed;

          $log.debug('speed', speedMs);
          scope.speed = ('0000' + Math.round(speedMs * scope.units.speedFactor)).slice(-4) - scope.goal;
 
            if (scope.speed >= 0) {
                
                if(scope.start_time) {
                    var now = Date.now();
                    
                    //if change in time is small, game wasn't paused
                    if(now-scope.start_time < 1000){
                        scope.timer+=(now-scope.start_time);
                    }
                    scope.start_time = now;
                }
                
                else {
                     scope.start_time = Date.now();
                     scope.timer = 0;
                     scope.speed_color = 'green'
                }
                
           } 
            else {
               
                if (scope.best_time<scope.timer){
                    scope.best_time = scope.timer;
                }
              
                scope.start_time = false;   
                scope.speed_color = 'red';
            }   

            
        });
      });


    }
  }
  
  
}])